'============================================================
' aTV_DVBViewer_wrapper v0.1 - 2011/02/05 - hasse@logoff.nu
'
' aTV script for adding schedules to DVBViewer
' This script is trigged via windows scheduled
' task created by aTV.
' It's (supposed) to work in the following manner;
'
' All instances of DVBViewer is stopped when a recording
' scheduled in aTV is about to start.
'
' When stopped, this script produces a new entry in
' DVBViewers timers.xml file. All other entries are removed!
'
' This script then start DVBViewer again and it recognizes
' that there's an scheduled item to record. By default
' DVBViewer is set to exit after the recording is done.
'
' script should be invoked with the 5 following parameters;
'
' - recording name
' - name of channel
' - start date (DD.MM.YYY)
' - start time (HH:MM:SS)
' - stop time (HH:MM:SS)
'
'======================================================================

' User settings - modify path to reflect your setup of DVBViewer

Dim strDirectory
strDirectory = "C:\Documents and Settings\All Users\Application Data\CMUV\DVBViewer"
Dim strFile
strFile = "timers.xml"

' =====================================================================
' Read parameters given at startup
' =====================================================================

Set objArgs = WScript.Arguments

If WScript.Arguments.Count <> 5 Then
   msgbox "Error - Did not get 5 arguments!"
   msgbox "Got " & WScript.Arguments.Count
   For Each strArg in objArgs
     WScript.Echo strArg
   Next
   WScript.Quit
End If

'=======================================================================
' Function to stop all instances of DVBViewer
'=======================================================================
strComputer = "."
strProcessToKill = "dvbviewer.exe"

SET objWMIService = GETOBJECT("winmgmts:" _
	& "{impersonationLevel=impersonate}!\\" _
	& strComputer & "\root\cimv2")

SET colProcess = objWMIService.ExecQuery _
	("Select * from Win32_Process Where Name = '" & strProcessToKill & "'")

count = 0
FOR EACH objProcess in colProcess
	objProcess.Terminate()
	count = count + 1
NEXT


SET WS = CreateObject("wscript.shell")
WS.Popup "Killed " & count & " instances of " _
         & strProcessToKill, 3, "Kill DVBViewer"


' =========================================================================
' Create a new timer.xml file in DVBViewer directory
' =========================================================================

Dim objFSO 'As FileSystemObject
Set objFSO = CreateObject("Scripting.FileSystemObject")

If objFSO.FolderExists(strDirectory) Then
  ' nop
Else
  WS.Popup "Oops, specified directory" & vbCr & vbLf & strDirectory & _
     vbCr & vbLf & "does not exist !" ,, "aTV Schedule start error!"
     WScript.Quit
End If

If objFSO.FileExists(strDirectory & "\" & "timers.bak") Then
  objFSO.DeleteFile strDirectory & "\" & "timers.bak"
  WS.Popup "Found and deleted old timers.bak file", 2, "aTV clean files"
End If


Dim objTextFile 'As Object
Dim blnOverwrite 'As Boolean
blnOverwrite = True
Set objTextFile = objFSO.CreateTextFile(strDirectory & "\" & strFile, blnOverwrite)

objTextFile.WriteLine("<?xml version=" & chr(34) & "1.0" & chr(34) & " encoding=" & chr(34) & "iso-8859-1" & chr(34) & "?>")
objTextFile.WriteLine("  <settings>")
objTextFile.WriteLine("    <section name=" & chr(34) & "VCR" & chr(34) & ">")
objTextFile.Write("      <entry name="& chr(34) & "0"& chr(34) & ">")

For Each strArg in objArgs
  objTextFile.Write(strArg & ";")
Next

objTextFile.WriteLine("4;-------;0;true;false</entry>")
objTextFile.WriteLine("    </section>")
objTextFile.WriteLine("  </settings>")
objTextFile.WriteLine("")

' Do some cleanup
objTextFile.Close
Set objTextFile = Nothing
Set objDirectory = Nothing
Set objFSO = Nothing

WS.Popup "Creating new timer.xml config" & vbCr & vbLf & "Restart of DVBViewer in 5" _
           & " seconds", 3, "DVBViewer restart"

' ==========================================================================
' Restart DVBViewer again after scheduled item in timer.xml is created
' ==========================================================================

WS.Run "dvbviewer.exe", 2, false
