import java.util.*;
import java.io.*;

class aTVBatch {

    public static void main(String[] args) {

        String encoder = "";
        String indir = "";
        String outdir = "";
        String program = "";
        String arguments = "";
        String fsuffix = "";
        String batchfile = "";
        String doscp = "";
		 
        String batfile = "";
        String newfilename = "";
        String postconvname = "";
        String busyname = "";

        ResourceBundle props = ResourceBundle.getBundle("jtv");
		
        try {
            encoder = props.getString("encoder");
            indir = props.getString("recdir");
            outdir = props.getString("outputdirectory");
            program = props.getString("program");
            arguments = props.getString("arguments");
            fsuffix = props.getString("filesuffix");
            batchfile = props.getString("batchfile");
            doscp = props.getString("doscp"); 
        		     	
        } catch (MissingResourceException mre) {
            System.out.println("Error reading properties! " + mre);
        }

        String[] toencode = new String[99];
        String message = "";
        int ix = 0;

        File f = new File(indir);
        String[] recordings = new String[f.list().length];

        recordings = f.list();

        // Find tagged files in directory
        for (int x = 0; x < recordings.length; x++) {
            if (recordings[x].contains("[T]")) {
                toencode[ix] = recordings[x];
                ix++;
            }
        }
        
        if (ix == 0) {
        	System.out.println("No tagged files found!\nExit with RC=10");
        	System.exit(10);
        }
        
        System.out.println("Found " + ix + " files tagged for conversion...\n");

		batfile = batfile + indir.substring(0,2) + "\r\n";
        batfile = batfile + "cd " + indir + "\r\n";
        
        for (int y = 0; y < ix; y++) {
		
            // Define name for original file after conversion [C]
            // To be safe, check for URL encoded variant aswell...
            postconvname = toencode[y].replace(".%5BT%5D.", ".[C].");
            postconvname = toencode[y].replace(".[T].", ".[C].");
            
            // Define name for original file during conversion [B] (busy)
            busyname = toencode[y].replace(".%5BT%5D.", ".[B].");
            busyname = toencode[y].replace(".[T].", ".[B].");
            
            // New name for converted file, no tags in it and with user suffix
            newfilename = toencode[y].replace(".%5BT%5D.", ".");
            newfilename = toencode[y].replace(".[T].", ".");	
            newfilename = newfilename.replace(newfilename.substring(
            				newfilename.lastIndexOf('.')),fsuffix);
			
			// Rename file to busyname
			batfile = batfile + "ren \"" + toencode[y] + "\" \"" + busyname + "\"\r\n";
							
            if (encoder.equalsIgnoreCase("HANDBRAKE")) {
            	
                batfile = batfile + program + " -i \"" + busyname
                        + "\" -o \"" + outdir + "\\" + newfilename + "\" "
                        + arguments;
                batfile = batfile + "\r\n";
			
            } else if (encoder.equalsIgnoreCase("FFMPEG")) {
                batfile = batfile + program + " -i \"" + busyname + "\" "
                        + arguments + " \"" + outdir + "\\" + newfilename + "\"";
                batfile = batfile + "\r\n";
            }
			
			
			/* Add support for additional encoding methods if needed here!
			else if (encode.equalsIgnoreCase("SOMETHING")) {
				batfile = batfile + "Something interesting....";
			} */
			
			
			// End of conversion types...
			
			// Rename file again
            batfile = batfile + "ren \"" + busyname + "\" \"" + postconvname + "\"";
            batfile = batfile + "\r\n";
			
            System.out.println("--> " + toencode[y]);
            
        }
        
        try {
			
            FileOutputStream outfile = new FileOutputStream(batchfile);
            Writer w = new BufferedWriter(new OutputStreamWriter(outfile, doscp));

            w.write(batfile);
            w.flush();
            w.close();
            System.out.println("\nCreated: " + batchfile);
      		
        } catch (Exception ioe) {
            System.out.println("Something went wrong: " + ioe);
        }
    }

}
