@echo off
REM *******************************************************
REM 
REM  Bat file to manually trigger aTVBatch to scan tagged
REM  recordings. Windows scheduled item will be added to
REM  start the produced bat-file at the given date and time.
REM 
REM  Usage;
REM  C:\atv\toolbox\<filename>.bat 21:00:00 2008/06/06
REM
REM *******************************************************

REM ************** Get some variables  ****************  

REM ** pushd ..
SET aTV_InstallDir=%cd%
REM ** popd

echo INSTALLDIR: %aTV_InstallDir%
FOR /f "tokens=2 delims== " %%a in ('findstr sysuser %aTV_InstallDir%\props\atv.properties') do set xusername=%%a
FOR /f "tokens=2 delims== " %%b in ('findstr syspass %aTV_InstallDir%\props\atv.properties') do set xpassword=%%b

echo USER: %xusername%
echo PASS: ***********

SET batfile=%aTV_InstallDir%\batch\aTV_compress.bat

REM *** Read user input of time to start batch or  *****
REM *** if empty calculate time 1 minute from now  *****

SET tid=%1
SET datum=%2

IF NOT "%tid%" == "" GOTO GO

SET /A hour=%time:~0,2%
SET /A min=%time:~3,2%
SET /A min=%min%+1

IF "%min%"=="60" (
 SET /A min="00"
 SET /A hour=%hour%+1
)

SET phour=0%hour%
SET pphour=%phour:~-2%

SET pmin=0%min%
SET ppmin=%pmin:~-2%

SET year=%date:~0,4%
SET month=%date:~5,2%
SET day=%date:~8,2%

SET tid=%pphour%:%ppmin%:00
SET datum=%year%/%month%/%day%

:GO

ECHO ^<BR^>Will use the following - time: %tid% and date: %datum%

REM **************************************************************
REM - Run aTVBatch and produce bat-file
REM - Working directory in this step must be
REM - where the aTVBatch class is present.
REM - Java must be available in the system.
REM **************************************************************

ECHO Deleting earlier created task if any...
DEL "C:\Windows\tasks\CONV_aTVBatch_manual.job"

CD %aTVInstallDir%

ECHO ^<BR^>******* aTVBatch output ********^<BR^>
java -classpath .;%aTV_InstallDir%\props;%aTV_InstallDir%\lib aTVBatch
ECHO ^<BR^>***** End aTVBatch output ******^<BR^>

REM **************************************************************
REM - Create scheduled task when the bat-file will be executed.
REM - Named of the scheduled task is fixed, so the can only
REM - be one created at the time...
REM **************************************************************

schtasks /create /tn "CONV_aTVBatch_manual" /tr  "\"%batfile%\" " /sc once /st %tid% /sd %datum% /ru %xusername% /rp %xpassword%
ECHO Task added, file conversion will start %datum% %tid%
